#!/bin/bash

DBUS_PATH=$1

function main() {
    local confirm_str="This tool conducts bad sector scans on all disk devices, which may require a considerable amount of time. Would you like to proceed?"

    local tr_confirm_str
    tr_confirm_str=$(Translate "${confirm_str}")

    local select
    select=$(ShowConfirmBox "${DBUS_PATH}" "${tr_confirm_str}" "question")
    if [ "${select}" == "no" ]; then
        exit 255
    fi

    local str
    local tr_str

    str="Initiating the bad sector scanning process. This procedure progresses at a leisurely pace, so please be patient!"
    tr_str=$(Translate "${str}")
    echo "${tr_str}"

    dev_list=$(SudoWrapper -a "fdisk -l | grep 'Disk /'| grep -v ram | awk '{print \$2}' | sed -e 's/：/:/g' |cut -d : -f 1")
    for dev in ${dev_list}; do
        local timestamp
        timestamp=$(date +"%Y%m%d%H%M%S")

        str="Scanning disk"
        tr_str=$(Translate "${str}")
        echo "${tr_str} [${dev}]..."
        SudoWrapper -a "badblocks -v -o /tmp/badblocks_${timestamp}.log ${dev}"
        bad_block=$(ls -l /tmp/badblocks_${timestamp}.log | awk '{print $5}')
        if [ $bad_block == 0 ]; then
            str="scanning completed. No disk errors were found!"
            tr_str=$(Translate "${str}")
            echo "[${dev}] ${tr_str}"
        else
            str="disk scan completed.some disk errors found!Please refer to the logfile for bad sector scan results:"
            tr_str=$(Translate "${str}")
	    log_files=`ll -st /tmp/badblocks*   |head -n 1 |awk '{print $10}'`
            echo "[${dev}] ${tr_str} $log_files"
        fi
    done
}

main
exit 0
